/**
 * A bare bones class that wraps some of the functions necessary to interface with angelscript.
 *
 * Xavier Shay, May 2004
 * spam@noreality.net
**/
#pragma once
#pragma warning (disable: 4786)

#include <io.h>

#include <string>
#include <list>
using namespace std;

#include "angelscript.h"

// This is a simple output stream class. Required for the angelscript call to build
class COutStream : public asIOutputStream
{
public:
	void AS_CALL Write(const char *text) { printf("%s", text); }
};

class CScriptEngine {
protected:
	asIScriptEngine *engine;
	asIScriptContext *ctx;
public:
	CScriptEngine();

	bool init();
	bool callScript(string function, list<asDWORD *> *args = 0x0, asDWORD *retVal = 0x0);
	bool callScript(int id, list<asDWORD *> *args = 0x0, asDWORD *retVal = 0x0);
	bool loadScript(string filename);
};
